<%@ page import="org.opencms.cache.*,org.opencms.file.*,org.opencms.flex.*,java.util.*"%>
<%@ taglib prefix="cms" uri="http://www.opencms.org/taglib/cms"  %>

<cms:include property="template" suffix="" element="head" />

The Flex cache organizes the cached objects efficiently by using a "last-recently-used" policy.
This page writes a large filler text to generate cacheable entries. If the byte size of all cached 
entries is raised up to the maximum byte size for all cached entries, the flex cache finalizes the 
last recently used entries to resize the cache down to the average byte size for all cached entries:

<%

// Warning: The possiblilty to cast the request this way might be removed in a later OpenCms release.
//          If possible, avoid this and use the method used in the other examples to 
//          gain access to the OpenCms system using the org.opencms.jsp.CmsJspActionElement
CmsFlexRequest req = (CmsFlexRequest)request;

org.opencms.jsp.CmsJspActionElement cms = new org.opencms.jsp.CmsJspActionElement(pageContext, request, response);
CmsFlexController controller = (CmsFlexController)request.getAttribute(CmsFlexController.ATTRIBUTE_NAME);
CmsFlexCache flexCache = null;
CmsLruCache entryLruCache = null;
int maxCacheByteSize = 0;
int avgCacheByteSize = 0;
int currentCacheByteSize = 0;
int currentCacheObjectCount = 0;
int cachedEntries = 0;
int keySize = 0;

if ((flexCache=controller.getCmsCache())!=null) {
	cachedEntries = flexCache.size();
	keySize = flexCache.keySize();

	if ((entryLruCache=flexCache.getEntryLruCache())!=null) {
		maxCacheByteSize = entryLruCache.getMaxCacheCosts();
		avgCacheByteSize = entryLruCache.getAvgCacheCosts();
		currentCacheByteSize = entryLruCache.getObjectCosts();
		currentCacheObjectCount = entryLruCache.size();
	}
}
%>

<p>

Cached keys: <font color="red"><b><%=keySize%></b></font><br>
Cached variations: <font color="red"><b><%=cachedEntries%></b></font><br>
Maximum size of all variations: <font color="red"><b><%=maxCacheByteSize%> bytes</b></font><br>
Average size of all variations: <font color="red"><b><%=avgCacheByteSize%> bytes</b></font><br>
Current size of all variations: <font color="red"><b><%=currentCacheByteSize%> bytes</b></font>


<form action="cache_lru_test.jsp" method="get">
<input type="hidden" name="dummy" value="<%=System.currentTimeMillis()%>">
<input type="submit" value="Reload this page" <% if (!cms.getRequestContext().currentProject().equals(cms.getCmsObject().readProject(CmsProject.ONLINE_PROJECT_ID)) && (!flexCache.cacheOffline() || !flexCache.isEnabled())) { %>disabled<% } %>>
</form>

<%        
        // check online project        
        if (cms.getRequestContext().currentProject().equals(cms.getCmsObject().readProject(CmsProject.ONLINE_PROJECT_ID))) {
       		if (!flexCache.isEnabled()) {
%>       		
<div style="border-color:#FF0000; border-style:solid; border-width:3px; padding:5px;"><h1 style="text-decoration:blink; color:#FF0000;">Warning!</h1>
<p><b>The FlexCache is currently not enabled!</b><br>
For the examples to work correctly, you have to enable the FlexCache as described on the page
<a href="configuration_options.html">Configuration options</a> in this documentation.</p></div>	
<%       			
       		}
        }
        
        // check offline project
        else {
       		if (!flexCache.isEnabled() || !flexCache.cacheOffline()) {
%>       		
<div style="border-color:#FF0000; border-style:solid; border-width:3px; padding:5px;"><h1 style="text-decoration:blink; color:#FF0000;">Warning!</h1>
<p><b>The FlexCache is currently not enabled for the offline projects!</b><br>
For the examples to work correctly, you have to view this documentation in the "online" project or to enable the FlexCache for the offline projects as described on the page
<a href="configuration_options.html">Configuration options</a> in this documentation.</p></div>
<%       			
       		}
        }
%>

<p>

Please refer to the <a href="administration.html">Flex Cache Administration</a> for further details about the cached keys and entries.

<cms:include property="template" suffix="" element="foot" />